﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;

namespace DynamicColumnCreatingMVVM
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        MainViewModel vm;
        public MainWindow()
        {
            InitializeComponent();

            vm = new MainViewModel();

            DataContext = vm;
        }

        private void XamDataGrid_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            MyViewModel elem =  vm.Data.First();
            for (int i = 0; i < elem.Parameters.Count; i++)
            {
                UnboundField field = new UnboundField
                {
                    Name = elem.Parameters[i].ParameterName,
                    BindingPath = new PropertyPath("Parameters[" + i + "]"),
                    
                    
                   Settings= new FieldSettings(){CellValuePresenterStyle=(this.Resources["ShowComboboxCellStyle"] as Style)}
                };

                e.FieldLayout.Fields.Add(field);
            }

        }
    }

    public class MainViewModel
    {
        public MainViewModel()
        {
            Data = new ObservableCollection<MyViewModel>();
            Random r = new Random();

            int inner = r.Next(5,15);
            for (int i = 0; i < 10; i++)
            {
                MyViewModel vm = new MyViewModel()
                {
                    Name = "Name " + i,
                    Parameters = new List<Parameter>()
                };
                List<string> availableValues = new List<string>();
                for(int t=0;t<11;t++)
                    availableValues.Add(t.ToString());

                for (int j = 0; j < inner; j++)
                {
                    vm.Parameters.Add(new Parameter { ParameterName = "Parameter " + j,  Value = r.Next(10).ToString(), AvailableValues=availableValues });
                }

                Data.Add(vm);
            }
        }
        
        public ObservableCollection<MyViewModel> Data { get; set; }
    }

    public class MyViewModel
    {

        public string Name { get; set; }

        public List<Parameter> Parameters { get; set; }

        

    }

    public class Parameter
    {

        public string ParameterName { get; set; }

        public string Value { get; set; }
        public List<string> AvailableValues { get; set; }

    }


}
